// module: Tableau.java
// auteur: felipe
// objet:  notre premier tableau a une dimension
// comment: un tableau est un objet => declaration et allocation

public class Tableau {

  // une methode qui prend un tableau en argument
  static int tableSomme(int t[]) { // passage par reference

     int somme = 0;
     for (int i=0; i<t.length; i++) { // parcours de tous les elts du tableau
       somme += t[i];
     }
     return somme;
  }

  public static void main(String[] args) {

    final int TAILLE = 5; // une constante

    int table []; // declaration que table est un tableau d'entiers 
    // NOTE: le tableau n'existe pas pour autant

    table = new int [TAILLE]; // allocation de TAILLE elements 

    // NOTE: on peut egalement declarer et allouer un tableau en une seule ligne:
    int table2 [] = new int [10]; // table2 contient 10 elements entiers

    // NOTE: les TAILLE elements de table sont initialises automatiquement a 0
    // la "preuve" (mais mieux vaut ne pas en tenir compte):
    System.out.println("Somme de la table non initialisee : " + tableSomme(table));

    // on range des valeurs dedans entre 1 et 20 (inclus)
    // double Math.random() retourne un double in [0,1[
    for (int i=0; i<TAILLE; i++)
      table[i] = (int) (1.+(Math.random()*20));

    // traitement sur la table initialisee
    System.out.println("Somme de la table initialisee : " + tableSomme(table));

  }
}



