/**
   Auteur: Mohamed Lokbani

   cet exemple prsente l'utilisation des constructeurs
   et de la fonction de recopie.

   jusqu' maintenant pour initialiser les champs, nous
   avons utilis une mthode donne (initialise).

   question: peux-t-on utiliser une mthode qui permet
    la fois de crer l'objet et d'initialiser ses champs?

   rponse: oui. Pour ce faire, il faudra utiliser les
   constructeurs.

   remarques: le constructeur porte le nom de la classe
   il ne retourne rien (ne pas mettre void)
   il peut y en avoir x nombres de constructeurs pas de limite.
   toute classe a un constructeur par dfaut, reprsent par:
   nom_classe()
   il cesse d'exister si vous dfinissez au moins un constructeur
   dans votre classe.

   
*/

class compte{
    // Dfinition des champs
    String nom;
    double actif;
    int limite; // limite de crdit
    
    // Dfinition des mthodes

    // constructeur dont les arguments vont servir  initialiser
    // les champs donnes de la classe.

    // vous pouvez avoir un constructeur avec ou sans arguments.
    public compte(String monnom,double monactif,int malimite){
	nom = monnom ;
	actif = monactif ;
	limite = malimite ;
    }

    /*
      si je veux recopier un objet dans un autre.
      Si A & B sont deux objets du type compte, alors
      l'opration A=B ralise une copie superficielle
      de l'objet B dans A.
      Si vous voulez faire une copie profonde, vous devez
      dfinir une mthode spciale.
      en java il existe une mthode pour le faire: la mthode
      "clone". Ca sort du cadre de ce cours.
    */

    public compte copie(){

	// on cre un objet et on retourne sa rfrence
	compte X = new compte(nom,actif,limite);
	return X;
    }

    // plus vraiment besoin vu que nous avons maintenant un constructeur
    //  notre disposition

    void initialise(){
	nom = "";
	actif = 0.0;
	limite = 2000;
    }
    double depot(double argent){
	actif += argent;
	return actif;
    }
    void affiche() {
	System.out.println("nom de la personne: " + nom);
	System.out.println("actif de son compte: " + actif);
	System.out.println("limite de crdit: " + limite);

    }
}

public class Testcompte1 {

    public static void main(String [] args){
	//a.initialise(); // avant
	compte a = new compte("toto",99,5000); // maintenant avec le constructeur
	compte b = a.copie(); // on copie l'objet a dans b.

	a.depot(50);
	a.affiche();
    }
}
